/* ptylaunch.c -- controls door launching, and does so in such a way
   as to give the door a terminal to work with.  hopefully. */

/* well, as launching w/o a tty isn't at all ready for prime time,
   we'll hold off on this shit here, too.  most of this is never
   called, we're sticking to the old routines. */

#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <termios.h>
#include <errno.h>
#include <sys/ioctl.h>

/* collision avoidance */
#define IN_BBS

#include <common.h>
#include <client.h>
#include <menu_codes.h>

extern BBS_Config *config;
extern BBS_Node *this_node;
extern int my_node;

void spawn_door(BBS_Menu *cur){

     char telnet[100];
     char dropfile[100];
     char tel[10];
     char logbuf[80];
     int flags;

     sprintf(dropfile,"%s/temp/doordrop%d",config->base_dir,this_node->node);

     if(writedrop(dropfile, cur) != 0) {
	  bbserr("Error launching door.\n");
	  sprintf(logbuf,"couldn't write door dropfile for node %d.\n",this_node->node);
	  log(logbuf);
	  return;
     }

     seteuid(0);

     sprintf(telnet, "%s %d", cur->action, this_node->node);
     endwin();
     system(telnet);
     refresh();

     seteuid(config->setuid);


}

int writedrop(char *filename, BBS_Menu *cur) {

/* Write out a dropfile of the users choosing, while faking local
   mode. */

     FILE *dropfile;

     if((dropfile = fopen(filename,"w")) == NULL)
          return 0xbeef;

     switch(cur->type) {
     case DOORSYS:
          fprintf(dropfile,"COM1\n"); /* port for ttywr4p */
          fprintf(dropfile,"57600\n"); /* 57600 baud */
          fprintf(dropfile,"8\n"); /* bits */
          fprintf(dropfile,"%d\n",this_node->node); /* node # */
          fprintf(dropfile,"N\nY\nY\nY\nY\n"); /* no baud lock, screen
                                                display, printer, page
                                                bell, caller alarm */
          /* begin obvious user data */
/* Fixed outputting error. "%ud" is syntactally incorrect and was printing
   an unsigned int and the letter 'd' to a file. This has been changed to
   just a %u */
          fprintf(dropfile,"%s\n",this_node->current_user->handle);
          fprintf(dropfile,"%s\n",this_node->current_user->city);
          fprintf(dropfile,"%s\n",this_node->current_user->phone);
          fprintf(dropfile,"%s\n",this_node->current_user->phone);
/*        fprintf(dropfile,"%s\n",this_node->current_user->crypt_pass); */
          fprintf(dropfile,"password\n");
          fprintf(dropfile,"%u\n",this_node->current_user->access);
          fprintf(dropfile,"12\n"); /* arbitrary logins */
          fprintf(dropfile,"01/01/98\n"); /* arb. last. login.  FIX */
          fprintf(dropfile,"%u\n", this_node->current_user->remaining);
          fprintf(dropfile,"%u\n", this_node->current_user->remaining/60);
          fprintf(dropfile,"GR\n"); /* assume user is ANSI enabled. FIX */
          fprintf(dropfile,"24\n"); /*hardcode screen size for now
                                      FIX */
          fprintf(dropfile,"N\n"); /* not an expert user */
          fprintf(dropfile,"1\n"); /* conferences registered */
          fprintf(dropfile,"1\n"); /* conf last in */
          fprintf(dropfile,"12/25/99\n"); /* exp. date (are doors y2k
					     compat?) */
          fprintf(dropfile,"%u\n",(int)this_node->current_user % 65536);
/* hmmm...  user number? */
          fprintf(dropfile,"X\n"); /* default protocol */
          fprintf(dropfile,"0\n0\n0\n9999\n"); /* who knows? */
          break;

     case DORINFO:
     case DORINFOREM:
          fprintf(dropfile, "%s\n", config->system_name);
          /* obnoxiously, dorinfox.def always wants a full name! */
          fprintf(dropfile, "%s\n", config->sysop); /*sysop name*/
          fprintf(dropfile, "\n");
          if(cur->type == DORINFOREM) {
	       fprintf(dropfile, "COM1\n"); /* lie about com 1 */
	       fprintf(dropfile, "57600 BAUD,N,8,1\n"); /* lie more */
          } else {
	       fprintf(dropfile, "COM0\n"); /* lie about com 1 */
	       fprintf(dropfile, "0 BAUD,N,8,1\n"); /* lie more */
          }
          fprintf(dropfile, "0\n"); /* lie about no network */
          fprintf(dropfile, "%s\n", this_node->current_user->handle);
          /* argh.  last names! */
          fprintf(dropfile, "\n");
          fprintf(dropfile, "%s\n", this_node->current_user->city);
          fprintf(dropfile, "1\n"); /* graphics level ?? FIX */
          fprintf(dropfile, "%u\n", this_node->current_user->access);
          fprintf(dropfile, "%d\n", this_node->current_user->remaining/60);
          fprintf(dropfile, "0\n"); /* lie and say FOSSIL - NO! */
          break;

     case AHPAH:
          fprintf(dropfile,"%s\n",this_node->current_user->handle);
          fprintf(dropfile,"LOCAL\n");
          break;

     case CHAIN_TXT:
     default:
          printf("Improper door configuration\n");
          fclose(dropfile);
          return 0xbeef;

     }

     fclose(dropfile);
     return 0;

}
