/* all of the data structures we use to manage the data we toss
   about.  yeehaw. */

#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <gdbm/ndbm.h>
#include <time.h>

#define MAX_NODES 32

/* set up our structure for a user record for the database. */

typedef struct _BBS_User {
     char handle[20];
     char first_name[20];
     char last_name[20];
     char phone[20];
     int node;
     unsigned int remaining;
     time_t last_login;
     unsigned int access;
     char e_mail[60];
     char crypt_pass[15];
     char address[2][60];
     char city[20];
     char state[20];
     char zip[20];
     char country[20];
     u_int32_t flags;
     unsigned short int color[16][3]; /* particular flags, bitmasked.
					 see below */
     int done;
     
} BBS_User;

/* defines to deal with user configged colors */
#define COL_PROMPT 9
#define COL_MENREG 1
#define COL_MENHI 2
#define COL_SEP 3
#define COL_NAME 4
#define COL_FLAG 5
#define COL_LABEL 6
#define COL_PRHI 7
#define COL_NORM 8
/* 9-15 unused, but harmless. */
#define COL_VAL1 14 /* space to expand the generic "colored value" flags */
#define COL_VAL2 15
/* color modifier flags */
#define COL_BLINK 0x01
#define COL_BRIGHT 0x10

/* flags for the user flags */
#define FL_HOTKEY 0x1


/* deal with data specific to what a given node is doing now. */

typedef struct _BBS_Node {
     int node;
     BBS_User *current_user;
     char current_menu[40];
     char area[36];
     char filearea[20];
     struct fqueue *file_queue;
     int avail;
     pid_t pid;
     int cur;
     char what[80];
     int done;
} BBS_Node;

/* and do the damn menus */

typedef struct _BBS_Menu {
     char key;
     char label[40];
     int access;
     int type;
     char action[80];
     int done;
} BBS_Menu;

/* messages which the nodes are waiting to get. */

typedef struct _BBS_Inc {
     int dest_node;
     int orig_node;
     unsigned long start_time;
     char type[79];
     char msg[2048];
} BBS_Inc;

/* login information */
typedef struct _BBS_Login {
     int node; /* what node did we get? */
     char key[20]; /* for when nodes get their own keys */
} BBS_Login;


	     
