#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <client.h>

extern BBS_Config *config;

int db_reply(int sock) {

     DB_Ret reply;

     if(read(sock, &reply, sizeof(DB_Ret)) < sizeof(DB_Ret)) 
	  return -1;
     
     if(reply.result != 0)
	  return -1;

     return reply.datasize;
     
}
	  
int db_conn(DB_Req *req) {

     int ret;
     struct sockaddr_in sockout;

     sockout.sin_family = AF_INET;
     sockout.sin_port = htons(config->db_port);
     sockout.sin_addr.s_addr = inet_addr(config->db_ip);

     ret = socket(AF_INET, SOCK_STREAM, 0);

     if(connect(ret, &sockout, sizeof(sockout)) == -1) {
	  perror("db_conn - connect");
          return -1;
     }

     write(ret, req, sizeof(DB_Req));

     return ret;

}

int big_read(int sock, void *dump, int size) {

     void *here;
     int x = 0;
     int r;

     /* keep trying reads until we've completed filling our memory
	region, or the other side has closed. */

     /* x tracks bytes already read. */

     while(x < size) {
	  here = dump + x;

	  /* did the socket close? */
	  if((r = read(sock, here, size-x)) < 1)
	       return x;
	  
	  x += r;
     }

}
