#include <stdio.h>
#include <curses.h>
#include <menu.h>

#include <common.h>
#include <client.h>

#include "disp.h"

int menu_sel(MENU *m) {

     int ret;
     WINDOW *mwin;
     int mrows, mcols;
     int ch;

     menu_opts_off(m, O_SHOWDESC);
     scale_menu(m, &mrows, &mcols);

     mwin = newwin(mrows+2, mcols+2, 1, 1);
     set_menu_win(m, mwin);
     keypad(mwin, TRUE);
     box(mwin, 0, 0);
     cbreak();

     set_menu_sub(m, derwin(mwin, mrows, mcols, 1, 1));
     post_menu(m);

     do {
	  ch = wgetch(mwin);
	  switch(ch) {
	  case '\n':
	  case KEY_EXIT:
	       ret = MAX_COMMAND+1;
	       break;
	  case KEY_DOWN:
	  case '2':
	       ret = REQ_NEXT_ITEM;
	       break;
	  case KEY_UP:
	  case '8':
	       ret = REQ_PREV_ITEM;
	       break;
	  case KEY_HOME:
	  case '7':
	       ret = REQ_FIRST_ITEM;
	       break;
	  case KEY_END:
	  case '1':
	       ret = REQ_LAST_ITEM;
	       break;
	  case KEY_NPAGE:
	  case '3':
	       ret = REQ_SCR_DPAGE;
	       break;
	  case KEY_PPAGE:
	  case '9':
	       ret = REQ_SCR_UPAGE;
	       break;
	  case KEY_LEFT:
	  case '4':
	  ret = REQ_LEFT_ITEM;
	  break;
	  case KEY_RIGHT:
	  case '6':
	       ret = REQ_RIGHT_ITEM;
	       break;
	  default: 
	       continue;
	       
	  }
     } while(menu_driver(m, ret) != E_UNKNOWN_COMMAND);
     
     nocbreak();
     unpost_menu(m);
     delwin(mwin);
     
     return ret;

}

/* prompt_box speak my thoughts.....  vent these... uh..  nevermind.. */

char *prompt_box(char *prompt) {
     
     WINDOW *box;
     char *ret;

     nocbreak();
     
     box = newwin(5, COLS-8, LINES/2, COLS+3);     
     immedok(box, TRUE);
     keypad(box, TRUE);
     idlok(box, TRUE);
  
     
     mvwprintw(box, 1, 5, "%s", prompt);

     mvwprintw(box, 3, 0, " ");
     right_justify(box, " ");

     

     /* it's badly fucked up. */

     ret = (char *)calloc(sizeof(char), COLS-8);
     mvwprintw(stdscr, LINES-5, 1, "%s ", prompt);
     getstr(ret);

     delwin(box); 

     return ret;

}
	       
