
#include <stdio.h>
#include <curses.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <string.h>

#include <common.h>
#include <client.h>

#include "nl2k_compile.h"

BBS_Config *config;
int my_node=0;

int parse_nl2k(char *filename);

main(int ac, char *av[]) {

     char opt;
     char olddb[80];
     char type[3];

     config = (BBS_Config *)malloc(sizeof(BBS_Config));
     read_system_config();

     if(ac != 1) {
	  parse_nl2k(av[1]);
	  return 0;
     }

     initscr();
     keypad(stdscr, TRUE);
     scrollok(stdscr, TRUE);
     immedok(stdscr, TRUE);
     
     opt = 0;

     while(opt != 'q') {
	  tConnect *node;
	  tAddress *lookup;
	  char addr[60];
	  char filename[80];

	  printw("Sysop's nodelist management tool\n");
	  printw("v)iew node, p)arse new list, m)erge list, q)uit: ");

	  cbreak();
	  opt = getch();
	  nocbreak();
	  
	  addch('\n');

	  switch(opt) {
	  case 'v':

	       lookup = (tAddress *)calloc(sizeof(tAddress),1);
	       addstr("Node to look up: ");
	       scanw("%hd:%hd/%hd.%hd@%s", &lookup->Zone,
		     &lookup->Net, &lookup->Node, &lookup->Point,
		     lookup->Domain);
	       addstr("Type: ");
	       scanw("%s", type);
	       node = read_nl2k(lookup, type);
	       if(node == NULL) {
		    addstr("Invalid node.\n");
		    break;
	       }

/* 	       printw("Addr: %hd:%hd/%hd.%hd@%s\nName: %s\n",node->Address.Zone,
		      node->Address.Net, node->Address.Node, 
		      node->Address.Point, node->Address.Domain,
		      node->Connect.SiteName);
*/
	       printw("Name: %s\nLocation: %s\nSysop: %s\n",
		      node->SiteName, node->SiteLoc, node->SysName);

	       free(node);
	       break;
	       
	  case 'p':
	       
	       addstr("Full path of raw list: ");
	       scanw("%s", filename);

	       if(parse_nl2k(filename) == 0)
		    addstr("Failure in parsing process.\n");

	       break;

	  case 'm':
	       addstr("Full path of raw list: ");
               scanw("%s", filename);
	       
	       if(parse_nl2k(filename) == 0) 
		    addstr("Failure in parsing process.\n");

	       break;
	  }
     }

     return 0;

}

int parse_nl2k(char *filename) {

     char *filenames[2];
     char base[80];

     sprintf(base, "%s/db", config->base_dir);
     filenames[0] = filename;
     filenames[1] = NULL;

     compile_main(filenames, base);
     return;

}

